apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ nexus_name }}
  name: {{ nexus_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ nexus_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ nexus_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ nexus_name }}
  strategy:
    recreateParams:
      timeoutSeconds: 1200
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ nexus_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ nexus_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ nexus_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: CONTEXT_PATH
          value: /
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HOME
          value: /nexus-data
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: INSTALL4J_ADD_VM_PARAMS
          value: {{ nexus_java_args | join(' ') }} -Djava.util.prefs.userRoot=/nexus-data/javaprefs
        - name: NEXUS_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ nexus_name }}-admin
        - name: NEXUS_ARTIFACTS_SERVICE_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ nexus_name }}-artifacts
        - name: NEXUS_BLOB_STORES
          value: "{{ nexus_blobstores | join(' ') }}"
        - name: NEXUS_DEPLOYER_SERVICE_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ nexus_name }}-deployer
        - name: NEXUS_JENKINS_ARTIFACTS_ACCOUNT
          valueFrom:
            secretKeyRef:
              key: username
              name: {{ nexus_name }}-artifacts
        - name: NEXUS_JENKINS_DEPLOYER_ACCOUNT
          valueFrom:
            secretKeyRef:
              key: username
              name: {{ nexus_name }}-deployer
        - name: NEXUS_PROMETHEUS_ACCOUNT
{% if do_exporters %}
          valueFrom:
            secretKeyRef:
              key: username
              name: {{ nexus_name }}-prometheus
        - name: NEXUS_PROMETHEUS_SERVICE_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ nexus_name }}-prometheus
{% else %}
          value: ""
        - name: NEXUS_PROMETHEUS_SERVICE_PASSWORD
          value: ""
{% endif %}
        - name: NEXUS_REPOSITORIES
          value: "{{ nexus_repositories | join(' ') }}"
        - name: OPENLDAP_BASE
{% if do_ldap %}
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=nexus,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: nexus-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ nexus_ldap_user_objectclass }}
{% endif %}
{% else %}
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: S3_ACCESS_KEY
{% if do_s3 %}
{% if nexus_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name | default('s3') }}-nexus
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name | default('s3') }}-nexus
        - name: S3_ENDPOINT
          value: {{ minio_api_address }}
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name | default('s3') }}-nexus
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name | default('s3') }}-nexus
{% elif nexus_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name | default('s3') }}-nexus
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name | default('s3') }}-nexus
        - name: S3_ENDPOINT
          value: {{ radosgw_api_address }}
        - name: S3_REGION
          value: ""
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name | default('s3') }}-nexus
{% endif %}
{% else %}
        - name: S3_BUCKET
          value: ""
        - name: S3_ENDPOINT
          value: ""
        - name: S3_REGION
          value: ""
        - name: S3_SECRET_KEY
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='nexus'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='nexus'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                reply=`curl -s -o /dev/null -w %{http_code} "http://127.0.0.1:8081/static/css/nexus-content.css"`; \
                if test "$reply" -lt 200 -o "$reply" -ge 400; then \
                    exit 1; \
                elif ! ls /nexus-data; then \
                    exit 2; \
                fi
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: nexus
        ports:
        - containerPort: 8081
        readinessProbe:
          failureThreshold: 5
          httpGet:
            path: /static/css/nexus-content.css
            port: 8081
            scheme: HTTP
          initialDelaySeconds: 60
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: {{ nexus_cpu_limit }}
            memory: {{ nexus_memory_limit }}
          requests:
            cpu: {{ nexus_cpu_request }}
            memory: {{ nexus_memory_request }}
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          exec:
            command:
            - sh
            - -c
            - |
                reply=`curl -s -o /dev/null -w %{http_code} "http://127.0.0.1:8081/static/css/nexus-content.css"`; \
                if test "$reply" -lt 200 -o "$reply" -ge 400; then \
                    exit 1; \
                elif ! ls /nexus-data; then \
                    exit 2; \
                fi
          failureThreshold: 38
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
{% endif %}
        volumeMounts:
{% if (do_ldap or do_lemon) and k8s_flavor != 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /nexus-data
          name: data
        - mountPath: /nexus-data/log
          name: tmp
          subPath: logs
{% if do_ldap or do_lemon %}
        - mountPath: /etc/openldap
          name: ldapconf
{% endif %}
        - mountPath: /usr/local/share/ca-certificates
          name: tmp
          subPath: ca-certificates
{% if do_exporters %}
      - env:
        - name: NEXUS_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ nexus_name }}-prometheus
        - name: NEXUS_HOST
          value: http://127.0.0.1:8081
        - name: NEXUS_USERNAME
          valueFrom:
            secretKeyRef:
              key: username
              name: {{ nexus_name }}-prometheus
{% if do_triggers == False or (opsimages | json_query("[?name=='nexusexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='nexusexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          initialDelaySeconds: 60
          periodSeconds: 15
          httpGet:
            path: /
            port: 9184
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9184
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
      terminationGracePeriodSeconds: {{ nexus_termination_timeout | default(120) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ nexus_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: tmp
      - name: data
        persistentVolumeClaim:
          claimName: {{ nexus_name }}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='nexus'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - nexus
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='nexus'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='nexusexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='nexusexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
